package com.jiuqi.mde;

import java.sql.SQLException;
import java.sql.PreparedStatement;
import com.jiuqi.util.JqLib;

public class MDEDimension
{
    public String name;
    public String title;
    public String fieldName;
    public boolean isString;
    public Object object;
    public String order;
    public static final String ORDER_NAME = "顺序号";
    public static final Integer DEFAULT_ORDER;
    public static String MIN_STR_DIM_VALUE;
    public static String MAX_STR_DIM_VALUE;
    public static Integer MIN_INT_DIM_VALUE;
    public static Integer MAX_INT_DIM_VALUE;
    
    static {
        DEFAULT_ORDER = new Integer(1);
        MDEDimension.MIN_STR_DIM_VALUE = "";
        MDEDimension.MAX_STR_DIM_VALUE = "\uffff\uffff\uffff\uffff\uffff\uffff\uffff\uffff";
        MDEDimension.MIN_INT_DIM_VALUE = new Integer(0);
        MDEDimension.MAX_INT_DIM_VALUE = new Integer(99999999);
    }
    
    public MDEDimension() {
        this.isString = true;
        this.order = "";
    }
    
    public Object getMinValue() {
        if (this.isString) {
            return MDEDimension.MIN_STR_DIM_VALUE;
        }
        return MDEDimension.MIN_INT_DIM_VALUE;
    }
    
    public Object getMaxValue() {
        if (this.isString) {
            return MDEDimension.MAX_STR_DIM_VALUE;
        }
        return MDEDimension.MAX_INT_DIM_VALUE;
    }
    
    public Object cloneValue(final Object dimValue) {
        return dimValue;
    }
    
    public Object parseValue(final String strValue) {
        if (strValue == null || strValue.length() == 0) {
            return null;
        }
        if (this.isString) {
            return strValue;
        }
        return new Integer((int)Long.parseLong(strValue, 16));
    }
    
    public String formatValue(final Object dimValue) {
        if (this.isString) {
            return (String)dimValue;
        }
        return JqLib.makeHexString((int)dimValue);
    }
    
    public String getSQLFilter(final String tablePrefix, final Object dimValue) {
        return this.getSQLFilter(tablePrefix, dimValue, false);
    }
    
    public String getSQLFilter(final String tablePrefix, final Object dimValue, final boolean isPrepared) {
        if (dimValue == null) {
            return "";
        }
        final StringBuffer filter = new StringBuffer(64);
        filter.append('(');
        if (tablePrefix != null) {
            filter.append(tablePrefix);
        }
        filter.append(this.fieldName);
        filter.append('=');
        if (isPrepared) {
            filter.append('?');
        }
        else if (this.isString) {
            filter.append('\'');
            filter.append((String)dimValue);
            filter.append('\'');
        }
        else if (dimValue instanceof Integer) {
            filter.append((int)dimValue);
        }
        else {
            filter.append(dimValue.toString());
        }
        filter.append(')');
        return filter.toString();
    }
    
    public int setParameter(final PreparedStatement ps, final Object value, final int index) throws SQLException {
        if (ps == null || value == null || index <= 0) {
            return index;
        }
        if (this.isString) {
            ps.setString(index, (String)value);
        }
        else if (value instanceof Integer) {
            ps.setInt(index, (int)value);
        }
        else {
            ps.setString(index, value.toString());
        }
        return index + 1;
    }
    
    public void appendInsertSql(final StringBuffer fieldsBuffer, final StringBuffer paramsBuffer) {
        fieldsBuffer.append(this.fieldName);
        fieldsBuffer.append(',');
        paramsBuffer.append("?,");
    }
    
    public void appendWhereClause(final StringBuffer sqlBuffer) {
        sqlBuffer.append(this.fieldName);
        sqlBuffer.append("=? AND ");
    }
    
    public static final MDEDimension createOrderDimension() {
        final MDEDimension dimension = new OrderDimension();
        return dimension;
    }
}
